// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION ;         // W( [J )
	float3 Normal          : NORMAL0 ;          // @( [J )
	float4 Diffuse         : COLOR0 ;           // fBt[YJ[
	float4 Specular        : COLOR1 ;           // XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;        // eNX`W
	float4 TexCoords1      : TEXCOORD1 ;		// TueNX`W
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 PPosition       : TEXCOORD0 ;        // W( ˉe )
	float4 Position        : SV_POSITION ;	// W( vWFNV )
} ;

// {p[^
struct DX_D3D11_VS_CONST_BUFFER_BASE
{
	float4		AntiViewportMatrix[ 4 ] ;				// A`r[|[gs
	float4		ProjectionMatrix[ 4 ] ;					// r[@@vWFNVs
	float4		ViewMatrix[ 3 ] ;						// [h@@r[s
	float4		LocalWorldMatrix[ 3 ] ;					// [J@@[hs

	float4		ToonOutLineSize ;						// gD[̗֊s̑傫
	float		DiffuseSource ;							// fBt[YJ[( 0.0f:}eA  1.0f:_ )
	float		SpecularSource ;						// XyLJ[(   0.0f:}eA  1.0f:_ )
	float		MulSpecularColor ;						// XyLJ[lɏZl( XyLŎgp )
	float		Padding ;
} ;

// ̑̍s
struct DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX
{
	float4		ShadowMapLightViewProjectionMatrix[ 3 ][ 4 ] ;			// VhE}bvp̃Cgr[sƃCgˉesZ
	float4		TextureMatrix[ 3 ][ 2 ] ;								// eNX`Wps
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_VS_BASE				: register( b1 )
{
	DX_D3D11_VS_CONST_BUFFER_BASE				g_Base ;
} ;

// ̑̍s
cbuffer cbD3D11_CONST_BUFFER_VS_OTHERMATRIX			: register( b2 )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX		g_OtherMatrix ;
} ;


// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lLocalPosition ;
	float4 lWorldPosition ;
	float4 lViewPosition ;


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW̃Zbg
	lLocalPosition.xyz = VSInput.Position ;
	lLocalPosition.w = 1.0f ;

	// WvZ( [Jr[vWFNV )
	lWorldPosition.x = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	VSOutput.Position.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )



	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// r[WeNX`WƂďo͂
	VSOutput.PPosition = lViewPosition ;

	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return VSOutput ;
}
