// sNZVF[_[̓
struct PS_INPUT
{
	float4 Diffuse         : COLOR0 ;       // fBt[YJ[
	float4 Specular        : COLOR1 ;       // XyLJ[
	float2 TexCoords0      : TEXCOORD0 ;    // eNX`W
	float4 LPPosition      : TEXCOORD1 ;    // Cg݂W( xy̓Cg̎ˉeWAz̓r[W )
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0          : SV_TARGET0 ;	// F
} ;

// 萔obt@sNZVF[_[{p[^
struct DX_D3D11_PS_CONST_BUFFER_BASE
{
	float4		FactorColor ;			// At@l

	float		MulAlphaColor ;			// J[ɃAt@lZ邩ǂ( 0.0f:ZȂ  1.0f:Z )
	float		AlphaTestRef ;			// At@eXgŎgprl
	float2		Padding1 ;

	int			AlphaTestCmpMode ;		// At@eXgr[h( DX_CMP_NEVER Ȃ )
	int3		Padding2 ;

	float4		IgnoreTextureColor ;	// eNX`J[pJ[
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_PS_BASE				: register( b1 )
{
	DX_D3D11_PS_CONST_BUFFER_BASE		g_Base ;
} ;


SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`

SamplerState g_DepthMapSampler              : register( s1 ) ;		// [xobt@eNX`
Texture2D    g_DepthMapTexture              : register( t1 ) ;		// [xobt@eNX`


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float TextureDepth ;
	float2 DepthTexCoord ;
	float4 DefaultOutput ;


	// eNX`J[̓ǂݍ
	TextureDiffuseColor = g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0 ) ;

	// o̓J[ = fBt[YJ[ * eNX`J[ + XyLJ[
	DefaultOutput = PSInput.Diffuse * TextureDiffuseColor + PSInput.Specular ;

	// o̓At@ = fBt[YAt@ * eNX`At@ * sx
	DefaultOutput.a = PSInput.Diffuse.a * TextureDiffuseColor.a * g_Base.FactorColor.a ;


	// [xeNX`̍WZo
	// PSInput.LPPosition.xy  -1.0f ` 1.0f ̒lȂ̂ŁA 0.0f ` 1.0f ̒lɂ
	DepthTexCoord.x = ( PSInput.LPPosition.x + 1.0f ) / 2.0f;

	// y͍Xɏ㉺]
	DepthTexCoord.y = 1.0f - ( PSInput.LPPosition.y + 1.0f ) / 2.0f;

	// [xobt@eNX`[x擾
	TextureDepth = g_DepthMapTexture.Sample( g_DepthMapSampler, DepthTexCoord );

	// eNX`ɋL^Ă[x( +␳l )yl傫牜ɂƂƂŋPx𔼕ɂ
	if( PSInput.LPPosition.z > TextureDepth + 25.0f )
	{
		DefaultOutput.rgb *= 0.5f;
	}

	// o̓J[Zbg
	PSOutput.Color0 = DefaultOutput;

	// o̓p[^Ԃ
	return PSOutput ;
}


